local mod = ...



-- Upgrade: Fishing Nets -------------------------------------------------------------------------------------

-- Assets
mod:registerAssetId("models/Upgrade1.fbx/Prefab/Fishing.Nets.Part", "PREFAB_UPGRADE_FISHING_NETS" )

-- Material
mod:registerAssetId("models/Upgrade1.fbx/Materials/Material.Net1", "MATERIAL_UPGRADE_NET1")
mod:overrideAsset({
    Id = "MATERIAL_UPGRADE_NET1",
    HasAlphaTest = true,
})

-- Grounding
for i = 1, 4 do
    mod:registerPrefabComponent("models/Upgrade1.fbx/Prefab/Fishing.Nets.Part/Net." .. string.sub("000" .. i, -3), { DataType = "COMP_GROUNDED" })
end
for i = 17, 19 do
    mod:registerPrefabComponent("models/Upgrade1.fbx/Prefab/Fishing.Nets.Part/Attach_Minor." .. string.sub("000" .. i, -3), { DataType = "COMP_GROUNDED" })
end

-- Assemblage
mod:registerAsset({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_UPGRADE_FISHING_NETS_ASSEMBLAGE",
	Name = "BUILDING_PART_UPGRADE_NETS_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_UPGRADE_FISHING_NETS" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "CRATE_ROPE_PART", OptionalAttachNodeString = "Attach_Minor.017" }, -- from Fantasy Decorations
			{ BuildingPart = "CRATE_ROPE_PART", OptionalAttachNodeString = "Attach_Minor.018" }, -- from Fantasy Decorations
			{ BuildingPart = "CRATE_ROPE_PART", OptionalAttachNodeString = "Attach_Minor.019" }, -- from Fantasy Decorations
		},
	},
})

-- Random
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_UPGRADE_FISHING_NETS",
    Name = "BUILDING_PART_UPGRADE_NETS_NAME",
    Category = "UPGRADE",
    AssetBuildingFunction = "BUILDING_FUNCTION_UPGRADE_TOOLS",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
        RandomPartList = {
            "BUILDING_PART_UPGRADE_FISHING_NETS_ASSEMBLAGE",
        },
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0,
            CameraPitchOffset = 0,
        },
    },
    HasMaximumInstancePerBuilding = true,
    MaximumInstancePerBuilding = 1,
    BuildingZone = {
        ZoneEntryList = {
            {
                Polygon = polygon.createRectangle( {3.8, 3.8}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true },
            },
        },
    },
    Cost = UpgradeCostNets,
})



-- Add to Building
mod:overrideAsset({
    Id = "BUILDING_FISHING_HUT",
    BuildingPartSetList = {
        Action = "APPEND",
        {
            Name = "BUILDING_PART_SETLIST_UPGRADE",
            BuildingPartList = {
                "BUILDING_PART_UPGRADE_FISHING_NETS",
            },
        },
    },
})

if (foundation.isModLoaded("a673e06c-5bfd-4325-bd33-398fbd9e5531")) then -- Fishing Shacks

    mod:overrideAsset({
        Id = "JK_FISHING_SHACKS",
        BuildingPartSetList = {
            Action = "APPEND",
            {
                Name = "BUILDING_PART_SETLIST_UPGRADE",
                BuildingPartList = {
                    "BUILDING_PART_UPGRADE_FISHING_NETS",
                },
            },
        },
    })

end

if (foundation.isModLoaded("0e119c21-edfd-4e2e-a079-0678b38c85c0")) then -- Fishing Ponds

    mod:overrideAsset({
        Id = "FISHPOND",
        BuildingPartSetList = {
            Action = "APPEND",
            {
                Name = "BUILDING_PART_SETLIST_UPGRADE",
                BuildingPartList = {
                    "BUILDING_PART_UPGRADE_FISHING_NETS",
                },
            },
        },
    })

end



-- Upgrade: Fishing Compost -------------------------------------------------------------------------------------

-- Building Function
mod:registerAsset({
    DataType = "BUILDING_FUNCTION",
    Id = "BUILDING_FUNCTION_UPGRADE_COMPOST",
    Name = "BUILDING_PART_UPGRADE_COMPOST_NAME",
    GameRuleModifierList = {
        {
            DataType = "GAME_RULE_MODIFIER_WORKPLACE_RECIPE",
            ResourceProducedToAdd = {
                {
                    Resource = "RESOURCE_COMPOST",
                    Quantity = 1,
                },
            },
        },
    },
})

-- Assets
mod:registerAssetId("models/Upgrade1.fbx/Prefab/Fishing.Compost.Part", "PREFAB_UPGRADE_FISHING_COMPOST" )

-- Grounding
for i = 20, 22 do
    mod:registerPrefabComponent("models/Upgrade1.fbx/Prefab/Fishing.Compost.Part/Attach_Minor." .. string.sub("000" .. i, -3), { DataType = "COMP_GROUNDED" })
end

-- Assemblage
mod:registerAsset({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_UPGRADE_FISHING_COMPOST_ASSEMBLAGE",
	Name = "BUILDING_PART_UPGRADE_NETS_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_UPGRADE_FISHING_COMPOST" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "BASKET_LARGE_FISH_PART", OptionalAttachNodeString = "Attach_Minor.020" }, -- from Fantasy Decorations
			{ BuildingPart = "BARREL_FISH_PART", OptionalAttachNodeString = "Attach_Minor.021" }, -- from Fantasy Decorations
			{ BuildingPart = "FISHING_NET", OptionalAttachNodeString = "Attach_Minor.022" }, -- from Fantasy Decorations
		},
	},
})

-- Random
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_UPGRADE_FISHING_COMPOST",
    Name = "BUILDING_PART_UPGRADE_COMPOST_NAME",
    Category = "UPGRADE",
    AssetBuildingFunction = "BUILDING_FUNCTION_UPGRADE_COMPOST",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
        RandomPartList = {
            "BUILDING_PART_UPGRADE_FISHING_COMPOST_ASSEMBLAGE",
        },
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0,
            CameraPitchOffset = 0,
        },
    },
    HasMaximumInstancePerBuilding = true,
    MaximumInstancePerBuilding = 1,
    BuildingZone = {
        ZoneEntryList = {
            {
                Polygon = polygon.createCircle( 2.0, {0.0, 0.0}, 8 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true },
            },
        },
    },
    Cost = UpgradeCostNets,
})



-- Add to Building
mod:overrideAsset({
    Id = "BUILDING_FISHING_HUT",
    BuildingPartSetList = {
        Action = "APPEND",
        {
            Name = "BUILDING_PART_SETLIST_UPGRADE",
            BuildingPartList = {
                "BUILDING_PART_UPGRADE_FISHING_COMPOST",
            },
        },
    },
})

if (foundation.isModLoaded("a673e06c-5bfd-4325-bd33-398fbd9e5531")) then -- Fishing Shacks

    mod:overrideAsset({
        Id = "JK_FISHING_SHACKS",
        BuildingPartSetList = {
            Action = "APPEND",
            {
                Name = "BUILDING_PART_SETLIST_UPGRADE",
                BuildingPartList = {
                    "BUILDING_PART_UPGRADE_FISHING_COMPOST",
                },
            },
        },
    })

end

if (foundation.isModLoaded("0e119c21-edfd-4e2e-a079-0678b38c85c0")) then -- Fishing Ponds

    mod:overrideAsset({
        Id = "FISHPOND",
        BuildingPartSetList = {
            Action = "APPEND",
            {
                Name = "BUILDING_PART_SETLIST_UPGRADE",
                BuildingPartList = {
                    "BUILDING_PART_UPGRADE_FISHING_COMPOST",
                },
            },
        },
    })

end

