local mod = ...



-- Upgrade: Methods -------------------------------------------------------------------------------------

-- Assets
mod:registerAssetId("models/Upgrade2.fbx/Prefab/Iron.Part", "PREFAB_UPGRADE_IRON" )

-- Grounding
for i = 19, 19 do
    mod:registerPrefabComponent("models/Upgrade2.fbx/Prefab/Iron.Part/Attach_Minor." .. string.sub("000" .. i, -3), { DataType = "COMP_GROUNDED" })
end

-- Assemblage
mod:registerAsset({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_UPGRADE_IRON_ASSEMBLAGE",
	Name = "BUILDING_PART_UPGRADE_MACHINERY_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_UPGRADE_IRON" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "CRANE_PART", OptionalAttachNodeString = "Attach_Minor.019" }, -- from Fantasy Decorations
		}
	},
})

-- Random
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_UPGRADE_IRON",
    Name = "BUILDING_PART_UPGRADE_MACHINERY_NAME",
    Category = "UPGRADE",
    AssetBuildingFunction = "BUILDING_FUNCTION_UPGRADE_TOOLS",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
        RandomPartList = {
            "BUILDING_PART_UPGRADE_IRON_ASSEMBLAGE",
        },
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0,
            CameraPitchOffset = 0,
        },
    },
    HasMaximumInstancePerBuilding = true,
    MaximumInstancePerBuilding = 1,
    BuildingZone = {
        ZoneEntryList = {
            {
                Polygon = polygon.createRectangle( {3.0, 1.9}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true },
            },
        },
    },
    Cost = UpgradeCostMachinery,
})



-- Name for single vanilla building parts
mod:overrideAsset({
    Id = "BUILDING_PART_IRON_SMELTER",
    Name = "IRON_SMELTER",
})



-- Add to Building
mod:overrideAsset({
    Id = "BUILDING_QUARRY_IRON_DEPOSIT",
    BuildingPartSetList = {
        Action = "APPEND",
        {
            Name = "BUILDING_PART_SETLIST_UPGRADE",
            BuildingPartList = {
                "BUILDING_PART_UPGRADE_IRON",
            },
        },
    },
})

mod:overrideAsset({
    Id = "BUILDING_IRON_SMELTER",
    BuildingPartSetList = {
        Action = "APPEND",
        {
            Name = "BUILDING_PART_SETLIST_UPGRADE",
            BuildingPartList = {
                "BUILDING_PART_UPGRADE_IRON",
            },
        },
    },
})
