local mod = ...



-- Upgrade: Vegetable Farm Tools -------------------------------------------------------------------------------------

-- Assets
mod:registerAssetId("models/Upgrade1.fbx/Prefab/VegetableFarm.Tools.Part", "PREFAB_UPGRADE_VEGETABLE_FARM_TOOLS" )

-- Grounding
for i = 8, 9 do
    mod:registerPrefabComponent("models/Upgrade1.fbx/Prefab/VegetableFarm.Tools.Part/Attach_Minor." .. string.sub("000" .. i, -3), { DataType = "COMP_GROUNDED" })
end

-- Assemblage
mod:registerAsset({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_UPGRADE_VEGETABLE_FARM_TOOLS_ASSEMBLAGE",
	Name = "BUILDING_PART_UPGRADE_TOOLS_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_UPGRADE_VEGETABLE_FARM_TOOLS" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "TOOLS_BARREL_FARM_PART", OptionalAttachNodeString = "Attach_Minor.008" }, -- from Fantasy Decorations
			{ BuildingPart = "TOOLS_RACK_FARM_PART", OptionalAttachNodeString = "Attach_Minor.009" }, -- from Fantasy Decorations
		}
	},
})

-- Random
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_UPGRADE_VEGETABLE_FARM_TOOLS",
    Name = "BUILDING_PART_UPGRADE_TOOLS_NAME",
    Category = "UPGRADE",
    AssetBuildingFunction = "BUILDING_FUNCTION_UPGRADE_TOOLS",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
        RandomPartList = {
            "BUILDING_PART_UPGRADE_VEGETABLE_FARM_TOOLS_ASSEMBLAGE",
        },
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0,
            CameraPitchOffset = 0.0
        },
    },
    HasMaximumInstancePerBuilding = true,
    MaximumInstancePerBuilding = 2,
    BuildingZone = {
        ZoneEntryList = {
            {
                Polygon = polygon.createRectangle( {4.0, 2.25}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true },
            },
        },
    },
    Cost = UpgradeCostTools,
})



-- Upgrade: Additional Field -------------------------------------------------------------------------------------

-- Assets
mod:registerAssetId("models/Upgrade1.fbx/Prefab/VegetableFarm.Workers.Part", "PREFAB_UPGRADE_VEGETABLE_FARM_WORKERS" )

-- Grounding
for i = 14, 16 do
    mod:registerPrefabComponent("models/Upgrade1.fbx/Prefab/VegetableFarm.Workers.Part/Attach_Minor." .. string.sub("000" .. i, -3), { DataType = "COMP_GROUNDED" })
end

-- Assemblage
mod:registerAsset({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_UPGRADE_VEGETABLE_FARM_WORKERS_ASSEMBLAGE",
	Name = "BUILDING_PART_UPGRADE_WORKERS_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_UPGRADE_VEGETABLE_FARM_WORKERS" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "SACK_CLOSED_PART", OptionalAttachNodeString = "Attach_Minor.014" }, -- from Fantasy Decorations
			{ BuildingPart = "CRATE1_PART", OptionalAttachNodeString = "Attach_Minor.015" }, -- from Fantasy Decorations
			{ BuildingPart = "BARREL1_PART", OptionalAttachNodeString = "Attach_Minor.016" }, -- from Fantasy Decorations
		}
	},
})

-- Random
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_UPGRADE_VEGETABLE_FARM_WORKERS",
    Name = "BUILDING_PART_UPGRADE_WORKERS_NAME",
    Category = "UPGRADE",
    AssetBuildingFunction = "BUILDING_FUNCTION_ASSIGNABLE_VEGETABLEFARM",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
        RandomPartList = {
            "BUILDING_PART_UPGRADE_VEGETABLE_FARM_WORKERS_ASSEMBLAGE",
        },
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0,
            CameraPitchOffset = 0.0
        },
    },
    HasMaximumInstancePerBuilding = true,
    MaximumInstancePerBuilding = 1,
    BuildingZone = {
        ZoneEntryList = {
            {
                Polygon = polygon.createCircle( 1.0, {0.0, 0.0}, 16 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true },
            },
        },
    },
    Cost = UpgradeCostField,
})



-- Add to Building
mod:overrideAsset({
    Id = "BUILDING_VEGETABLEFARM",
    BuildingPartSetList = {
        Action = "APPEND",
        {
            Name = "BUILDING_PART_SETLIST_UPGRADE",
            BuildingPartList = {
                "BUILDING_PART_UPGRADE_VEGETABLE_FARM_TOOLS",
                "BUILDING_PART_UPGRADE_VEGETABLE_FARM_WORKERS",
            },
        },
    },
})
