local mod = ...



-- Upgrade: Methods -------------------------------------------------------------------------------------

-- Assets
mod:registerAssetId("models/Upgrade2.fbx/Prefab/Weaver.Part", "PREFAB_UPGRADE_WEAVER_HUT" )

-- Grounding
for i = 10, 11 do
    mod:registerPrefabComponent("models/Upgrade2.fbx/Prefab/Weaver.Part/Attach_Minor." .. string.sub("000" .. i, -3), { DataType = "COMP_GROUNDED" })
end

-- Assemblage
mod:registerAsset({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_UPGRADE_WEAVER_HUT_ASSEMBLAGE",
	Name = "BUILDING_PART_UPGRADE_MACHINERY_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_UPGRADE_WEAVER_HUT" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "CLOTH_LINE1_PART", OptionalAttachNodeString = "Attach_Minor.010" }, -- from Fantasy Decorations
			{ BuildingPart = "CLOTH_LINE2_PART", OptionalAttachNodeString = "Attach_Minor.011" }, -- from Fantasy Decorations
		}
	},
})

-- Random
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_UPGRADE_WEAVER_HUT",
    Name = "BUILDING_PART_UPGRADE_MACHINERY_NAME",
    Category = "UPGRADE",
    AssetBuildingFunction = "BUILDING_FUNCTION_UPGRADE_TOOLS",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
        RandomPartList = {
            "BUILDING_PART_UPGRADE_WEAVER_HUT_ASSEMBLAGE",
        },
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0,
            CameraPitchOffset = 0,
        },
    },
    HasMaximumInstancePerBuilding = true,
    MaximumInstancePerBuilding = 1,
    BuildingZone = {
        ZoneEntryList = {
            {
                Polygon = polygon.createRectangle( {3.0, 4.0}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true },
            },
        },
    },
    Cost = UpgradeCostMachinery,
})



-- Name for single vanilla building parts
mod:overrideAsset({
    Id = "BUILDING_PART_WEAVER_HUT",
    Name = "WEAVER_HUT",
})



-- Add to Building
mod:overrideAsset({
    Id = "BUILDING_WEAVER_HUT",
    BuildingPartSetList = {
        Action = "APPEND",
        {
            Name = "BUILDING_PART_SETLIST_UPGRADE",
            BuildingPartList = {
                "BUILDING_PART_UPGRADE_WEAVER_HUT",
            },
        },
    },
})
